<template>
  <div>
    <div v-show="!hideWizard" class="card">
      <div class="card-header">
        <h3 class="card-title">
          <span v-text="editmode ? 'Saving campaign edit' : 'Saving campaign create'"></span>
        </h3>
        <div class="card-tools">
          <button type="button" @click="closeWizard()" class="close" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
      </div>
      <form-wizard id="saving-campaign-wizard" ref="wizard" color="rgb(46, 160, 46)">
        <hr />
        <tab-content
          title="Saving campaign general information"
          icon="fa fa-info"
          :before-change="beforeMainSavCampInfoTabSwitch"
        >
          <form>
            <div class="form-group">
              <label for="income">Name</label>
              <input
                v-model="form.name"
                id="income"
                type="text"
                name="name"
                placeholder="Name"
                class="form-control"
                :class="{ 'is-invalid': form.errors.has('name') }"
              />
              <div class="help-block invalid-feedback">The name field is required and must be text</div>
            </div>
            <div class="form-group">
              <label for="income">Income, €</label>
              <input
                v-model="form.income"
                id="income"
                type="text"
                name="income"
                placeholder="Income"
                class="form-control"
                :class="{ 'is-invalid': form.errors.has('income') }"
              />
              <div
                class="help-block invalid-feedback"
              >The income field is required and must be a number</div>
            </div>
            <div class="form-group">
              <label for="date">Campaign start date</label>
              <br />
              <vue-monthly-picker
                :class="{ 'is-invalid': form.errors.has('date') }"
                v-model="selectedMonth"
                alignment="left"
                placeholder="Select month"
              ></vue-monthly-picker>
              <div
                class="help-block invalid-feedback"
              >Saving campaign for this month is already created</div>
            </div>
          </form>
          <hr />
        </tab-content>
        <tab-content
          title="Saving campaign categories information"
          icon="fa fa-list-ul"
          :before-change="editmode ? updateCampaign : createCampaign"
        >
          <p>You can define how much you want to spend in every category and observe how you follow your plan. Campaign expires on selected month.</p>

          <form>
            <div class="saving-campaign-box">
              <table class="table table-hover table-striped">
                <tbody>
                  <tr>
                    <th>Category name</th>
                    <th>Amount I want to spend, €</th>
                    <th>30 days before until now period expenses, €</th>
                    <th>Annual expenses average per month, €</th>
                  </tr>
                  <tr v-for="(category,index) in form.categories" :key="index++">
                    <td>{{category.name}}</td>
                    <td>
                      <div class="form-group">
                        <input
                          id="amount"
                          v-model="category.wanted_amount"
                          type="text"
                          name="amount"
                          placeholder="Amount"
                          class="form-control"
                          :class="{ 'is-invalid': checkError(index-1, 'wanted_amount') }"
                        />
                        <div
                          class="help-block invalid-feedback"
                        >The wanted amount field is required and must be a number</div>
                      </div>
                    </td>
                    <td>{{ category.amount.toFixed(2) }} €</td>
                    <td>{{ category.yearAvg.toFixed(2) }} €</td>
                  </tr>
                </tbody>
              </table>
            </div>
          </form>
          <hr />
        </tab-content>
      </form-wizard>
    </div>
  </div>
</template>

<script>
import moment from "moment";
import VueMonthlyPicker from "vue-monthly-picker";
export default {
  components: {
    VueMonthlyPicker,
    moment // todo not used
  },
  data() {
    return {
      needToRefreshWizard: false,
      predictedBalance: "",
      campaigns: {},
      hideWizard: true,
      moment: moment,
      editmode: false,
      categories: {},
      selectedMonth: moment(new Date()).format("YYYY-MM"),
      form: new Form({
        id: "",
        categories: "",
        income: "",
        status: "",
        date: null,
        name: ""
      })
    };
  },

  methods: {
    cleanWizard() {
      this.form.income = "";
      this.form.date = moment(new Date()).format("YYYY-MM");
      this.form.name = "";
      this.form.id = "";
    },

    closeWizard() {
      this.hideWizard = true;
      this.needToRefreshWizard = true;
    },

    beforeMainSavCampInfoTabSwitch() {
      this.form.date = moment(this.selectedMonth).format("YYYY-MM");

      if (this.form.date && this.form.name && this.form.income) {
        return true;
      } else {
        swal(
          "Failed!",
          "You must fill all fields before the next step",
          "warning"
        );
        return false;
      }
    },

    checkError(index, label) {
      let line = "categories." + index + "." + label;
      if (this.form.errors.has(line)) {
        return true;
      }
      return false;
    },

    editCampaign() {
      axios
        .get("api/saving-campaign/" + this.editCampaignId + "/edit")
        .then(response => {
          this.form.income = response.data.income;
          this.form.date = moment(response.data.date).format("YYYY-MM");
          this.selectedMonth = this.form.date;
          this.form.name = response.data.name;
          this.form.id = response.data.id;
          this.setCategories(response.data.component_categories);
        })
        .catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
    },

    setCategories(categories) {
      for (let i = 0; i < categories.length; i++) {
        for (let j = 0; j < this.form.categories.length; j++) {
          if (this.form.categories[j].id == categories[i].id) {
            this.form.categories[j].wanted_amount =
              categories[i].pivot.wanted_amount;
          }
        }
      }
    },

    createCampaign() {
      let predictedBalance = this.getPredictableBalance();

      if (isNaN(predictedBalance)) {
        swal({
          type: "error",
          title: "Oops...",
          text: "You must complete all fields correctly before campaign start"
        });
      } else {
        let textStatus = "";
        if (predictedBalance >= 0) {
          textStatus = "save";
        } else {
          textStatus = "loose";
          predictedBalance = predictedBalance * -1;
        }
        this.form.date = moment(this.selectedMonth).format("YYYY-MM");
        swal({
          title: "Are you sure that you want to create this saving campaign?",
          text: "You are going to " + textStatus + " " + predictedBalance + "e",
          type: "warning",
          showCancelButton: true,
          confirmButtonColor: "#3085d6",
          cancelButtonColor: "#d33",
          confirmButtonText: "Yes, create it!"
        }).then(result => {
          if (result.value) {
            this.$Progress.start();
            this.form
              .post("api/saving-campaign")
              .then(() => {
                swal("Created!", "Information has been created.", "success");
                this.$Progress.finish();
                Fire.$emit("loadCampaignsAndCategories");
                this.hideWizard = true;
                return true;
              })
              .catch(error => {
                this.errorSwal();
                this.$Progress.fail();
                console.log(error);
                return false;
              });
          }
        });
      }

      return false;
    },

    errorSwal() {
      if (
        this.form.errors.has("income") ||
        this.form.errors.has("date") ||
        this.form.errors("name")
      ) {
        swal(
          "Failed!",
          "There was something wrong. Please check out again previous step.",
          "warning"
        );
      } else {
        swal("Failed!", "There was something wrong.", "warning");
      }
    },

    updateCampaign() {
      let predictedBalance = this.getPredictableBalance();

      if (isNaN(predictedBalance)) {
        swal({
          type: "error",
          title: "Oops...",
          text: "You must complete all fields correctly before campaign start"
        });
      } else {
        let textStatus = "";
        if (predictedBalance >= 0) {
          textStatus = "save";
        } else {
          textStatus = "loose";
          predictedBalance = predictedBalance * -1;
        }
        this.form.date = moment(this.selectedMonth).format("YYYY-MM");
        swal({
          title: "Are you sure that you want to create this saving campaign?",
          text: "You are going to " + textStatus + " " + predictedBalance + "e",
          type: "warning",
          showCancelButton: true,
          confirmButtonColor: "#3085d6",
          cancelButtonColor: "#d33",
          confirmButtonText: "Yes, create it!"
        }).then(result => {
          if (result.value) {
            this.$Progress.start();
            this.form
              .put("api/saving-campaign/" + this.form.id)
              .then(() => {
                swal("Updated!", "Information has been updated.", "success");
                this.$Progress.finish();
                Fire.$emit("loadCampaignsAndCategories");
                this.hideWizard = true;
              })
              .catch(error => {
                this.errorSwal();
                this.$Progress.fail();
                console.log(error);
                return false;
              });
          }
        });
      }

      return true;
    },

    getPredictableBalance() {
      for (let i = 0; i < this.form.categories; i++) {
        if (isNaN(this.form.categories[i].wanted_amount)) {
          return NaN;
        }
      }

      let sum = this.form.categories.reduce((sum, object) => {
        sum = Number(sum) + Number(object.wanted_amount);
        return sum;
      }, 0);

      return (this.form.income - sum).toFixed(2);
    },

    loadCategories() {
      axios
        .get("api/categories", {
          params: {
            paginate: 0
          }
        })
        .then(response => {
          this.form.categories = response.data;
        })
        .catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
    }
  },

  created: function() {
    Fire.$on("CreateSavingCampaign", () => {
      this.hideWizard = false;
      this.editmode = false;
      this.loadCategories();

      if (this.needToRefreshWizard && !this.hideWizard && this.$refs.wizard) {
        this.cleanWizard();
        this.$refs.wizard.navigateToTab(0);
        this.selectedMonth = moment(new Date()).format("YYYY-MM");
      }

      this.needToRefreshWizard = true;
    });

    Fire.$on("EditSavingCampaign", id => {
      this.editCampaignId = id;
      this.hideWizard = false;
      this.editmode = true;
      this.loadCategories();
      this.editCampaign();

      if (this.needToRefreshWizard && !this.hideWizard && this.$refs.wizard) {
        this.$refs.wizard.navigateToTab(0);
      }

      this.needToRefreshWizard = true;
    });
  }
};
</script>